// menu.h          Lg, July 17, 1995


#ifndef MENU_H
#define MENU_H


#include <iostream>
#include "simpleList.h"
using namespace std;


class menu : protected simpleStringList {
//    ====
  protected:
    long int* _linecountp;  // for error messages
    long int _dummy;
  public:
    typedef void (*proc)();
    menu() { _dummy=-1; _linecountp=&_dummy; }
    menu( long int* linecountp ) { _linecountp = linecountp; }
    //
    void def( const char* name, proc action, const char* comment="",
    /*   ===  */                                     int invisible=0 );
                                          // OBS: strings are not copied
    int execute_command( const char* name );     // returns 0 iff command
    //  ===============                             name not in the list
    int get_and_execute_command( istream& is );  // returns 0 iff command
    //  =======================                     name not in the list
    void print_command_list( ostream& os, int mode=0, int tab=15 );
    //   ==================               // mode=0: just names, on one line
                                          // mode=1: as table, with comments
};


class menu_item : protected simpleStringListEntry {
//    =========
    friend class menu;
    menu::proc _action;
    const char* _comment;
    int _invisible;
};


#endif
